
;       hl = pacced data (*.pac), de = destination address

.SECTION "PacBoy - Unpac"

Unpac:
        ld      a,[hl+]         ; get info byte for next block

        rrca                    ; bits fall in place here
        jr      c,_norm         ; non-compressed data coming up

        ld      b,a             ; number of bytes in repeated block
        ld      a,[hl+]         ; get lookback byte (distance)
        push    hl

        add     e               ; calculate lookback address
        ld      l,a
        ld      a,d
        adc     $ff
        ld      h,a
_palp:
        ld      a,[hl+]         ; copy b bytes from there
        ld      [de],a
        inc     de
        dec     b
        jr      nz,_palp

        pop     hl              ; already incremented before push
        jr      Unpac           ; go proceed with next block

_norm:
        and     $7f             ; low 7 bits are byte count
        ret     z               ; end mark check
        ld      b,a
_nolp:
        ld      a,[hl+]         ; copy b bytes of non-compressed data
        ld      [de],a
        inc     de
        dec     b
        jr      nz,_nolp

        jr      Unpac           ; go proceed with next block

.ENDS
